This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 635626 - ABI break without change in .so version or pkg-config file for libpeas-gtk
ABI break without change in .so version or pkg-config file for libpeas-gtk
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: libpeas (Show other bugs)
19
All Linux
low Severity high
: ---
: ---
Assigned To: Bastien Nocera
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-09-20 07:03 EDT by Daniel Berrange
Modified: 2013-06-17 06:16 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-06-17 06:16:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Daniel Berrange 2010-09-20 07:03:57 EDT
Description of problem:
In Fedora 14 libpeas-gtk-1.0 links against gtk2

# grep Requires /usr/lib64/pkgconfig/libpeas-gtk-1.0.pc 
Requires: glib-2.0 >= 2.14, gtk+-2.0 >= 2.16, libpeas-1.0 >= 0.5.5
# ldd /usr/lib64/libpeas-gtk-1.0.so.0.502.3 | grep gtk
	libgtk-x11-2.0.so.0 => /usr/lib64/libgtk-x11-2.0.so.0 (0x00007f326ab53000)

In Fedora 15 rawhide, the version same version links against gtk3

# grep Requires /usr/lib64/pkgconfig/libpeas-gtk-1.0.pc 
Requires: glib-2.0 >= 2.14, gtk+-3.0 >= 2.90, libpeas-1.0 >= 0.5.5
# ldd /usr/lib64/libpeas-gtk-1.0.so.0.502.3 | grep gtk
	libgtk-x11-3.0.so.0 => /usr/lib64/libgtk-x11-3.0.so.0 (0x00007f85467ed000)


This is a problem on many levels. Apps built against libpeas-gtk in Fedora 14 will just crash & burn, because GTK3 is not ABI compatible with GTK2, you'll get missing symbols or worse. It is also typically not possible to just rebuild the app in question against GTK3, because GTK3 is not source level compatible with GTK2 and many libraries aren't ported to GTK3 either. Finally you can't load both GTK2 and GTK3 into the same process.

Fedora 15 needs to ship 2 versions of libpeas-gtk, one built against GTK2, and one built against GTK3 with a *different* so version & different pkgconfig file.


Version-Release number of selected component (if applicable):
libpeas-0.5.5-1.fc15.x86_64

How reproducible:


Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
Comment 1 Daniel Berrange 2010-09-20 08:57:18 EDT
Interestingly the configure.ac file from libpeas has this comment

dnl We currently allow building libpeas with Gtk+ 2.0 for testing purposes and
dnl technology preview. but do *not* distribute such a version!

Based on that comment, should F14 even be distributing libpeas-gtk.so against GTK2 ?  Clearly upstream don't want it done, which is likely why they haven't taken care to ensure a different .soname for GTK2 vs GTK3 builds.

So it seems to me like there are three options

 - Switch F14 libpeas-gtk to GTK3
 - Remove libpeas-gtk from F14 completely
 - Convince upstream they really do want to support GTK2 and GTK3 with a new soname+pkgconfig for GTK3 to allow parallel install with GTK2 builds.
Comment 2 Fedora End Of Life 2013-04-03 14:29:18 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 3 Bastien Nocera 2013-06-17 06:16:25 EDT
Too late, closing.

Note You need to log in before you can comment on or make changes to this bug.